Page MenuHomePhabricator

Extend 'requires' section of extension.json to include extensions
Closed, ResolvedPublic

Description

See this discussion on wikitech-l: https://lists.wikimedia.org/pipermail/wikitech-l/2015-October/083797.html

In short, extension.json has a 'requires' section where you can specify required MediaWiki core versions for an extension. It would be great if this section could be expanded to include 3rd party extensions, to handle cases where a 3rd party extension depends on another (for example, VikiSemanticTitle and VikiTitleIcon are plugins to the VIKI extension, and thus require VIKI to be installed).

Event Timeline

Jason.ji created this task.Oct 30 2015, 7:23 PM
Jason.ji raised the priority of this task from to Normal.
Jason.ji updated the task description. (Show Details)
Jason.ji added a subscriber: Jason.ji.
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptOct 30 2015, 7:23 PM

Change 250060 had a related patch set uploaded (by Florianschmidtwelzow):
ExtensionRegistration: Implement Extension dependencies

https://gerrit.wikimedia.org/r/250060

Florian claimed this task.Oct 30 2015, 7:36 PM
Florian added a subscriber: Legoktm.
Ltrlg added a subscriber: Ltrlg.Nov 1 2015, 12:18 AM

I agree, that this could be a part of this RfC (which sounds really great btw), but I would call it a very little one. The RfC goes far beyond: how to use extension.json's machine-readable format to provide a way for semi-automated extension/skin installations and upgrades, dependency management and correct downlpadable version in, e.g., ExtensionDistributor.

Having the possibility to name dependencies in extensions is, apart from that, a good idea and a step in the right direction, even of the RfC will not be implemented (which I don't hope), or if it takes very long to implement it. Also, we balready have MediaWiki core support in the require section :)

So I don't see this RfC as a blocker (I'm not sure, how you @Spage mean your comment, so sorry if I misunderstood you, and you don't think so, too :)).

Legoktm renamed this task from Extend 'requires' section of extension.json to include 3rd party extensions to Extend 'requires' section of extension.json to include extensions.Feb 27 2016, 12:46 AM
Legoktm added a subscriber: Florian.

Given that @Legoktm has identified this as a blocker for T88596, and given that this seems to be stalled, should we try adding this to the TechCom-RFC backlog? Turning this into an TechCom-RFC is technically as simple as adding the tag. Perhaps before doing that, summarizing the discussion on https://gerrit.wikimedia.org/r/250060 and capturing that in the description of this task that would be helpful. In particular, one can efficiently summarize the Gerrit review discussion by reading through the discussion and capturing the controversial, unanswered questions.

J5lx added a subscriber: J5lx.Jul 20 2016, 4:22 PM

Change 250060 had a related patch set uploaded (by Florianschmidtwelzow):
registration: Allow specifying extension dependencies

https://gerrit.wikimedia.org/r/250060

Change 325117 had a related patch set uploaded (by Florianschmidtwelzow):
registration: Don't let extensions load lately

https://gerrit.wikimedia.org/r/325117

Change 325118 had a related patch set uploaded (by Florianschmidtwelzow):
registration: Generalize CoreVersionChecker to VersionChecker

https://gerrit.wikimedia.org/r/325118

Paladox added a subscriber: Paladox.Dec 3 2016, 8:27 PM

Change 325117 merged by jenkins-bot:
registration: Don't let extensions load late

https://gerrit.wikimedia.org/r/325117

Change 325118 merged by jenkins-bot:
registration: Generalize CoreVersionChecker to VersionChecker

https://gerrit.wikimedia.org/r/325118

Change 250060 merged by jenkins-bot:
registration: Allow specifying extension dependencies

https://gerrit.wikimedia.org/r/250060

Jdforrester-WMF closed this task as Resolved.Dec 16 2016, 4:30 AM
Jdforrester-WMF added a subscriber: Jdforrester-WMF.

\o/